<id>
Anti-Spam Question for YaBB 2.5
</id>

<version>
0.2
</version>

<mod info>
Description
-----------
This Mod will add a random question which must be answered on registration.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload AntispamQuestion.pl, AntispamQuestion.lng and RegQuestions.txt to their relevant directories in ASCII mode.
4) Go into Admin Center => BoardMod Mods => Anti-Spam Question to configure the settings.

Files to edit
-------------
AdminIndex.pl
Admin/AdminSubList.pl
Admin/ModList.pl
Languages/English/Admin.lng
Languages/English/Error.lng
Languages/English/Register.lng
Sources/Register.pl

Version History
---------------
0.1 - First Release - 24th September 2011
0.2 - Added ability to have multiple answers and added Admin option for case-sensitive/insensitive answers - 7th November 2011
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://boardmod.org
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
    $reg_question_mod = "reg_question|$mod_list{'reg_question'}|$mod_list{'reg_question1'}|";
    push (@boardmod_mods, "$reg_question_mod");

</add before>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'referer_control2',"Admin.pl&Refcontrol2",
</search for>

<add after>
# Anti-Spam Question Mod Start
'reg_question',"AntispamQuestion.pl&RegQuestion",
'reg_question2',"AntispamQuestion.pl&RegQuestion2",
'reg_question_add',"AntispamQuestion.pl&RegQuestionAdd",
'reg_question_delete',"AntispamQuestion.pl&RegQuestionDelete",
'reg_question_edit',"AntispamQuestion.pl&RegQuestionEdit",
'reg_question_edit2',"AntispamQuestion.pl&RegQuestionEdit2",
# Anti-Spam Question Mod End
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$reg_question_mod = "Anti-Spam Question|Derek Barnstorm|This Mod will add a random question which must be answered on registration. [<span class=\"small\"><a href=\"$adminurl?action=reg_question\" style=\"font-weight: bold;\">Anti-Spam Question Settings</a></span>]|0.2|7th November 2011";
	push (@installed_mods, "$reg_question_mod");
	
</add before>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%smtp_txt = (
</search for>

<add before>
'reg_question' => 'Anti-Spam Question', # Anti-Spam Question Mod
'reg_question1' => 'Anti-Spam Question Settings', # Anti-Spam Question Mod
</add before>

<edit file>
Languages/English/Error.lng
</edit file>

<search for>
'no_reg_reason'			=> "Without giving a reason for applying for membership we cannot process your application.",
</search for>

<add after>
'no_reg_question'		=> "You didn't answer the verification question. Please go back and try again.",
'wrong_reg_question'	=> "The verification question is wrong. Please go back and try again.",
</add after>

<edit file>
Languages/English/Register.lng
</edit file>

<search for>
);

%pwstrengthmeter_txt = (
</search for>

<add before>
'error_verification_question' => 'You must answer the verification question.',
</add before>

<edit file>
Sources/Register.pl
</edit file>

<search for>
			<input type="text" maxlength="30" name="verification" id="verification" size="30" /> *
		</td>
	</tr>~;
	}
</search for>

<add after>
    # Anti-Spam Question Mod Start
    if (-e "$vardir/RegQuestionSet.txt") { require "$vardir/RegQuestionSet.txt"; }
    if ($en_reg_question) {
        srand;
        fopen(REGQUESTION, "<$vardir/RegQuestions.txt") || &fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
        rand($.) < 1 && ($reg_questions = $_) while <REGQUESTION>;
        fclose(REGQUESTION);
        ($reg_question_id, $reg_question, undef) = split(/\|/, $reg_questions);
         $yymain .= qq~
    <tr>
        <td class="windowbg" align="right" valign="top">
            <label for="reg_question"><b>$reg_question</b></label>
        </td>
        <td class="windowbg2" align="left" valign="top">
            <input type="text" name="reg_question" id="reg_question" size="30" /> *
            <input type="hidden" name="reg_question_id" value="$reg_question_id" /> 
        </td>
    </tr>~;
    }
    # Anti-Spam Question Mod End
</add after>

<search for>
			document.creator.verification.focus();
			return false;
		}
</search for>

<replace>
			document.creator.verification.focus();
			return false;
		}~ .

		($en_reg_question ? qq~
		if (document.creator.reg_question.value == '') {
			alert("$register_txt{'error_verification_question'}");
			document.creator.reg_question.focus();
			return false;
		}~ : '')

		. qq~
</replace>

<search for>
	if ($regcheck) { require "$sourcedir/Decoder.pl"; &validation_check($member{'verification'}); }
</search for>

<add after>

    # Anti-Spam Question Mod Start
    if (-e "$vardir/RegQuestionSet.txt") { require "$vardir/RegQuestionSet.txt"; }
    if ($en_reg_question) {
        fopen(REGQUESTION, "<$vardir/RegQuestions.txt") || &fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
        @reg_question = <REGQUESTION>;
        fclose(REGQUESTION);
        foreach my $reg_questions (@reg_question) {
            chomp $reg_questions;
            if ($reg_questions =~ /$FORM{'reg_question_id'}/) {
               (undef, undef, $reg_answer) = split(/\|/, $reg_questions);
            }
        }
        $FORM{'reg_question'} =~ s/\A\s+//;
        $FORM{'reg_question'} =~ s/\s+\Z//;
        unless ($reg_question_cs) {
            $reg_answer = lc($reg_answer);
            $FORM{'reg_question'} = lc($FORM{'reg_question'});
        }
        &fatal_error("no_reg_question") if $FORM{'reg_question'} eq '';
        @reganswer = split(/,/, $reg_answer);
        foreach (@reganswer) {
            $_ =~ s/\A\s+//;
            $_ =~ s/\s+\Z//;
        }
        unless (grep { $FORM{'reg_question'} eq $_ } @reganswer) { &fatal_error("wrong_reg_question"); }
    }
    # Anti-Spam Question Mod End
</add after>










