###############################################################################
# AntispamQuestion.pl                                                         #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.5 Anniversary Edition                                #
# Packaged:       July 04, 2010                                               #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2010 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$antispamquestionplver = 'YaBB 2.5 AE $Revision: 0.2 $';
if ($action eq 'detailedversion') { return 1; }

if (!-e "$vardir/RegQuestionSet.txt") { &RegQuestion2; }
require "$vardir/RegQuestionSet.txt";

&LoadLanguage('AntispamQuestion');

sub RegQuestion { 
	
    &is_admin_or_gmod;
    
    if ($en_reg_question) { $chk_reg_question = qq~ checked="checked"~; }
    if ($reg_question_cs) { $chk_reg_question_cs = qq~ checked="checked"~; }
    
    fopen(REGQUESTION, "<$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    @reg_questions = <REGQUESTION>;
    fclose(REGQUESTION);
    
    $total_questions = @reg_questions || 0;
    
    if ($total_questions) {
        $header_row = qq~ colspan="4"~;
        $show_questions = qq~
<tr class="catbg" style="font-weight: bold; font-size: 11px;">
    <td style="width: 43%;">$reg_question_txt{'question'}</td>
    <td style="width: 43%;">$reg_question_txt{'answer'}</td>
    <td style="width: 7%;">$reg_question_txt{'edit'}</td>
    <td style="width: 7%;">$reg_question_txt{'delete'}</td>
</tr>~;

        foreach my $question (sort { $a <=> $b } @reg_questions) {
            chomp $question;
            ($reg_question_id, $reg_question, $reg_answer) = split(/\|/, $question);
             $show_questions .= qq~
<tr class="windowbg2">
    <td>$reg_question</td>
    <td>$reg_answer</td>
    <td>
    <form action="$adminurl?action=reg_question_edit" method="post">
      <input type="hidden" name="reg_question_id" value="$reg_question_id" />
      <input class="button" type="submit" value="$reg_question_txt{'edit'}" />
    </form>
    </td>
    <td>
    <form action="$adminurl?action=reg_question_delete" method="post">
      <input type="hidden" name="reg_question_id" value="$reg_question_id" />
      <input class="button" type="submit" value="$reg_question_txt{'delete'}" onclick="return confirm('$reg_question_txt{'confirm'}');"/>
    </form>
    </td>
</tr>~;
        } 
    } else { 
        $header_row = "";
        $show_questions = qq~
<tr class="windowbg2">
    <td>$reg_question_txt{'no_questions'}</td>
</tr>~;
    }

    $yymain = qq~
<form action="$adminurl?action=reg_question2" method="post">
<div class="bordercolor" style="padding: 0px; width: 99%; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<colgroup>
    <col width="50%" />
    <col width="50%" />
</colgroup>
<tr>
    <th class="titlebg" colspan="2" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $reg_question_txt{'question_settings'}</th>
</tr>
<tr class="windowbg2" style="vertical-align: top;">
    <td><label for="en_reg_question">$reg_question_txt{'enable_question'}</label></td>
    <td><input type="checkbox" name="en_reg_question" id="en_reg_question" value="1"$chk_reg_question /></td>   
</tr>
</tr>
<tr class="windowbg2" style="vertical-align: top;">
    <td><label for="reg_question_cs">$reg_question_txt{'case_sensitive'}</label></td>
    <td><input type="checkbox" name="reg_question_cs" id="reg_question_cs" value="1"$chk_reg_question_cs /></td>   
</tr>
</table>
</div>
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<tr>
    <th class="titlebg" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $admin_txt{'10'}</th>
</tr>
<tr>
    <td class="catbg" style="text-align: center; vertical-align: middle;"><input class="button" type="submit" value="$admin_txt{'10'}" /></td>
</tr>
</table>
</div>
</form>
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<tr>
    <th class="titlebg"$header_row style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $reg_question_txt{'questions'} ($total_questions)</th>
</tr>
$show_questions
</table>
</div>
<form action="$adminurl?action=reg_question_add" method="post">
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<colgroup>
    <col width="25%" />
    <col width="75%" />
</colgroup>
<tr>
    <th class="titlebg" colspan="2" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $reg_question_txt{'new_question'}</th>
</tr>
<tr class="windowbg2" style="vertical-align: top; font-weight: bold;">
    <td><label for="reg_question">$reg_question_txt{'question'}:</label></td>
    <td><input type="text" name="reg_question" id="reg_question" size="60" /></td>
</tr>
<tr class="windowbg2" style="vertical-align: top; font-weight: bold;">
    <td><label for="reg_answer">$reg_question_txt{'answer'}:<br /><span class="small" style="font-weight: normal;">$reg_question_txt{'answer_desc'}</span></label></td>
    <td><input type="text" name="reg_answer" id="reg_answer" size="60" /></td>  
</tr>
</table>
</div>
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<tr>
    <th class="titlebg" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $admin_txt{'10'}</th>
</tr>
<tr>
    <td class="catbg" style="text-align: center; vertical-align: middle;"><input class="button" type="submit" value="$reg_question_txt{'add_question'}" /></td>
</tr>
</table>
</div>
</form>
~;

    $yytitle = $mod_list{'reg_question1'};
    $action_area = "reg_question";
    &AdminTemplate;
    exit;

}

sub RegQuestion2 {
	
    &is_admin_or_gmod;
	
    $en_reg_question = $FORM{'en_reg_question'} || "0";
    $reg_question_cs = $FORM{'reg_question_cs'} || "0";

    my $regset = << "EOF";
###############################################################################
# RegQuestionSet.txt (Antispam Question configurations)                       #
###############################################################################

\$en_reg_question = $en_reg_question; # Set to 1 to enable Antispam Question
\$reg_question_cs = $reg_question_cs; # Set to 1 for answers to be case-sensitive

1;
EOF

    fopen(REGSETS, ">$vardir/RegQuestionSet.txt");
    print REGSETS $regset;
    fclose(REGSETS);

    if ($action eq "reg_question2") {
        $yySetLocation = qq~$adminurl?action=reg_question~;
        &redirectexit;
    }

}

sub RegQuestionAdd {

    &is_admin_or_gmod;
    
    $reg_question = $FORM{'reg_question'};
    $reg_answer   = $FORM{'reg_answer'};
      
    if ($reg_question eq '') { &admin_fatal_error("invalid_value","$reg_question_txt{'question'}"); }
    if ($reg_answer eq '') { &admin_fatal_error("invalid_value","$reg_question_txt{'answer'}"); }

    fopen(REGQUESTIONS, ">>$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    print REGQUESTIONS "$date|$reg_question|$reg_answer\n";
    fclose(REGQUESTIONS);
	
    if ($action eq "reg_question_add") {
        $yySetLocation = qq~$adminurl?action=reg_question~;
        &redirectexit;
    }

}

sub RegQuestionEdit {

    &is_admin_or_gmod;

    $id = $FORM{'reg_question_id'};
    my $question_edit = "";
	
    fopen(REGQUESTIONS, "<$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    @reg_questions = <REGQUESTIONS>;
    fclose(REGQUESTIONS);
    
	foreach my $question (@reg_questions) { 
        chomp $question;
        if ($question =~ /$id/) {
            $question_edit = $question; last;
        }
    }
    ($reg_question_id, $reg_question, $reg_answer) = split(/\|/, $question_edit);
    
    $yymain = qq~
<form action="$adminurl?action=reg_question_edit2" method="post">
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<colgroup>
    <col width="25%" />
    <col width="75%" />
</colgroup>
<tr>
    <th class="titlebg" colspan="2" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $reg_question_txt{'edit_question'}</th>
</tr>
<tr class="windowbg2" style="vertical-align: top; font-weight: bold;">
    <td><label for="reg_question">$reg_question_txt{'question'}:</label></td>
    <td><input type="text" name="reg_question" id="reg_question" size="60" value="$reg_question" /></td>
</tr>
<tr class="windowbg2" style="vertical-align: top; font-weight: bold;">
    <td><label for="reg_answer">$reg_question_txt{'answer'}:<br /><span class="small" style="font-weight: normal;">$reg_question_txt{'answer_desc'}</span></label></td>
    <td><input type="text" name="reg_answer" id="reg_answer" size="60" value="$reg_answer" /><input type="hidden" name="reg_question_id" id="reg_question_id" value="$reg_question_id" /></td>  
</tr>
</table>
</div>
<div class="bordercolor" style="padding: 0px; width: 99%; margin-top: 1em; margin-left: 0px; margin-right: auto;">
<table width="100%" cellspacing="1" cellpadding="4">
<tr>
    <th class="titlebg" style="text-align: left; vertical-align: middle;"><img src="$imagesdir/preferences.gif" alt="" border="0" /> $admin_txt{'10'}</th>
</tr>
<tr>
    <td class="catbg" style="text-align: center; vertical-align: middle;"><input class="button" type="submit" value="$admin_txt{'10'} $reg_question_txt{'question'}" />&nbsp;<input type="button" class="button" value="$reg_question_txt{'cancel'}" onclick="location.href='$adminurl?action=reg_question';" /></td>
</tr>
</table>
</div>
</form>~;

    $yytitle = $mod_list{'reg_question1'};
    &AdminTemplate;
    exit;
    
}

sub RegQuestionEdit2 {

    &is_admin_or_gmod;
    
    $reg_question_id = $FORM{'reg_question_id'};
    $reg_question = $FORM{'reg_question'};
    $reg_answer = $FORM{'reg_answer'};
    
    if ($reg_question eq '') { &admin_fatal_error("invalid_value","$reg_question_txt{'question'}"); }
    if ($reg_answer eq '') { &admin_fatal_error("invalid_value","$reg_question_txt{'answer'}"); }

    fopen(REGQUESTIONS, "<$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    @reg_questions = <REGQUESTIONS>;
    fclose(REGQUESTIONS);
	
    @question = grep (!/$reg_question_id/, @reg_questions);
    push(@question, "$reg_question_id|$reg_question|$reg_answer");
    $question = join("", @question);
	
    fopen(REGQUESTIONS, ">$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    print REGQUESTIONS "$question\n";
    fclose(REGQUESTIONS);
	
    if ($action eq "reg_question_edit2") {	
        $yySetLocation = qq~$adminurl?action=reg_question~;
        &redirectexit;
    }
    
}

sub RegQuestionDelete {

    &is_admin_or_gmod;

    fopen(REGQUESTIONS, "<$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    @reg_questions = <REGQUESTIONS>;
    fclose(REGQUESTIONS);

    fopen(REGQUESTIONS, ">$vardir/RegQuestions.txt") || &admin_fatal_error("cannot_open","$vardir/RegQuestions.txt", 1);
    print REGQUESTIONS grep (!/$FORM{'reg_question_id'}/, @reg_questions);
    fclose(REGQUESTIONS);
    
    if ($action eq "reg_question_delete") {
        $yySetLocation = qq~$adminurl?action=reg_question~;
        &redirectexit;
    }
    
}

1;